<?php
/**
 * InlineResponse20065ContentAllOfItemsInner
 *
 * PHP version 7.3
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * TANSS API
 *
 * ## Documentation of the TANSS API. Version: 5.8.22.1  ### older versions Older versions of the API documentation can be found here: * [Docs for 5.8.21.6](https://api-doc.tanss.de/5.8.21.6/) * [Docs for 5.8.21.3](https://api-doc.tanss.de/5.8.21.3/) * [Docs for 5.8.21.1](https://api-doc.tanss.de/5.8.21.1/) * [Docs for 5.8.20.5](https://api-doc.tanss.de/5.8.20.5/) * [Docs for 5.8.20.4](https://api-doc.tanss.de/5.8.20.4/) * [Docs for 5.8.20.2](https://api-doc.tanss.de/5.8.20.2/) * [Docs for 5.8.19.3](https://api-doc.tanss.de/5.8.19.3/)
 *
 * The version of the OpenAPI document: 5.8.22.1
 * Contact: support@tanss.de
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.0.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Tanss\Model;

use \ArrayAccess;
use \SLIS\Adapter\Tanss\ObjectSerializer;

/**
 * InlineResponse20065ContentAllOfItemsInner Class Doc Comment
 *
 * @category Class
 * @description represents an item in a checklist
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<TKey, TValue>
 * @template TKey int|null
 * @template TValue mixed|null
 */
class InlineResponse20065ContentAllOfItemsInner implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'inline_response_200_65_content_allOf_items_inner';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'id' => 'int',
        'checklistId' => 'int',
        'type' => 'string',
        'heading' => 'string',
        'description' => 'string',
        'entryPoint' => 'bool',
        'nextItemId' => 'int',
        'serviceText' => 'string',
        'hidden' => 'bool',
        'action' => '\SLIS\Adapter\Tanss\Model\InlineResponse20065ContentAllOfItemsItemsAction',
        'vars' => '\SLIS\Adapter\Tanss\Model\InlineResponse20048ContentItemsAllOfVarsInner[]'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'id' => null,
        'checklistId' => null,
        'type' => null,
        'heading' => null,
        'description' => null,
        'entryPoint' => null,
        'nextItemId' => null,
        'serviceText' => null,
        'hidden' => null,
        'action' => null,
        'vars' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'checklistId' => 'checklistId',
        'type' => 'type',
        'heading' => 'heading',
        'description' => 'description',
        'entryPoint' => 'entryPoint',
        'nextItemId' => 'nextItemId',
        'serviceText' => 'serviceText',
        'hidden' => 'hidden',
        'action' => 'action',
        'vars' => 'vars'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'checklistId' => 'setChecklistId',
        'type' => 'setType',
        'heading' => 'setHeading',
        'description' => 'setDescription',
        'entryPoint' => 'setEntryPoint',
        'nextItemId' => 'setNextItemId',
        'serviceText' => 'setServiceText',
        'hidden' => 'setHidden',
        'action' => 'setAction',
        'vars' => 'setVars'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'checklistId' => 'getChecklistId',
        'type' => 'getType',
        'heading' => 'getHeading',
        'description' => 'getDescription',
        'entryPoint' => 'getEntryPoint',
        'nextItemId' => 'getNextItemId',
        'serviceText' => 'getServiceText',
        'hidden' => 'getHidden',
        'action' => 'getAction',
        'vars' => 'getVars'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    public const TYPE_TEXT_FIELD = 'TEXT_FIELD';
    public const TYPE_REQUIRED_FIELD = 'REQUIRED_FIELD';
    public const TYPE_OPTIONAL_FIELD = 'OPTIONAL_FIELD';
    public const TYPE_INCLUDED_CHECKLIST = 'INCLUDED_CHECKLIST';
    public const TYPE_REQUIRED_TEXT_FIELD = 'REQUIRED_TEXT_FIELD';
    public const TYPE_OPTIONAL_TEXT_FIELD = 'OPTIONAL_TEXT_FIELD';
    public const TYPE_REQUIRED_MULTISELECT = 'REQUIRED_MULTISELECT';
    public const TYPE_OPTIONAL_MULTISELECT = 'OPTIONAL_MULTISELECT';
    public const TYPE_EVENT_CONTAINER = 'EVENT_CONTAINER';
    public const TYPE_APPROVAL_PROCESS = 'APPROVAL_PROCESS';

    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getTypeAllowableValues()
    {
        return [
            self::TYPE_TEXT_FIELD,
            self::TYPE_REQUIRED_FIELD,
            self::TYPE_OPTIONAL_FIELD,
            self::TYPE_INCLUDED_CHECKLIST,
            self::TYPE_REQUIRED_TEXT_FIELD,
            self::TYPE_OPTIONAL_TEXT_FIELD,
            self::TYPE_REQUIRED_MULTISELECT,
            self::TYPE_OPTIONAL_MULTISELECT,
            self::TYPE_EVENT_CONTAINER,
            self::TYPE_APPROVAL_PROCESS,
        ];
    }

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['id'] = $data['id'] ?? null;
        $this->container['checklistId'] = $data['checklistId'] ?? null;
        $this->container['type'] = $data['type'] ?? null;
        $this->container['heading'] = $data['heading'] ?? null;
        $this->container['description'] = $data['description'] ?? null;
        $this->container['entryPoint'] = $data['entryPoint'] ?? null;
        $this->container['nextItemId'] = $data['nextItemId'] ?? null;
        $this->container['serviceText'] = $data['serviceText'] ?? null;
        $this->container['hidden'] = $data['hidden'] ?? null;
        $this->container['action'] = $data['action'] ?? null;
        $this->container['vars'] = $data['vars'] ?? null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        $allowedValues = $this->getTypeAllowableValues();
        if (!is_null($this->container['type']) && !in_array($this->container['type'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value '%s' for 'type', must be one of '%s'",
                $this->container['type'],
                implode("', '", $allowedValues)
            );
        }

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets id
     *
     * @return int|null
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param int|null $id id of the item
     *
     * @return self
     */
    public function setId($id)
    {
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets checklistId
     *
     * @return int|null
     */
    public function getChecklistId()
    {
        return $this->container['checklistId'];
    }

    /**
     * Sets checklistId
     *
     * @param int|null $checklistId id of the checklist, which the item is contained in
     *
     * @return self
     */
    public function setChecklistId($checklistId)
    {
        $this->container['checklistId'] = $checklistId;

        return $this;
    }

    /**
     * Gets type
     *
     * @return string|null
     */
    public function getType()
    {
        return $this->container['type'];
    }

    /**
     * Sets type
     *
     * @param string|null $type defines the type of a checklist item
     *
     * @return self
     */
    public function setType($type)
    {
        $allowedValues = $this->getTypeAllowableValues();
        if (!is_null($type) && !in_array($type, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value '%s' for 'type', must be one of '%s'",
                    $type,
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['type'] = $type;

        return $this;
    }

    /**
     * Gets heading
     *
     * @return string|null
     */
    public function getHeading()
    {
        return $this->container['heading'];
    }

    /**
     * Sets heading
     *
     * @param string|null $heading headinh / title of the checklist item
     *
     * @return self
     */
    public function setHeading($heading)
    {
        $this->container['heading'] = $heading;

        return $this;
    }

    /**
     * Gets description
     *
     * @return string|null
     */
    public function getDescription()
    {
        return $this->container['description'];
    }

    /**
     * Sets description
     *
     * @param string|null $description description / text of the checklist item
     *
     * @return self
     */
    public function setDescription($description)
    {
        $this->container['description'] = $description;

        return $this;
    }

    /**
     * Gets entryPoint
     *
     * @return bool|null
     */
    public function getEntryPoint()
    {
        return $this->container['entryPoint'];
    }

    /**
     * Sets entryPoint
     *
     * @param bool|null $entryPoint true if this is the first item of a checklist
     *
     * @return self
     */
    public function setEntryPoint($entryPoint)
    {
        $this->container['entryPoint'] = $entryPoint;

        return $this;
    }

    /**
     * Gets nextItemId
     *
     * @return int|null
     */
    public function getNextItemId()
    {
        return $this->container['nextItemId'];
    }

    /**
     * Sets nextItemId
     *
     * @param int|null $nextItemId id of the \"next\" field in the process chain
     *
     * @return self
     */
    public function setNextItemId($nextItemId)
    {
        $this->container['nextItemId'] = $nextItemId;

        return $this;
    }

    /**
     * Gets serviceText
     *
     * @return string|null
     */
    public function getServiceText()
    {
        return $this->container['serviceText'];
    }

    /**
     * Sets serviceText
     *
     * @param string|null $serviceText text which is used when creating a support
     *
     * @return self
     */
    public function setServiceText($serviceText)
    {
        $this->container['serviceText'] = $serviceText;

        return $this;
    }

    /**
     * Gets hidden
     *
     * @return bool|null
     */
    public function getHidden()
    {
        return $this->container['hidden'];
    }

    /**
     * Sets hidden
     *
     * @param bool|null $hidden true if thes field is hidden
     *
     * @return self
     */
    public function setHidden($hidden)
    {
        $this->container['hidden'] = $hidden;

        return $this;
    }

    /**
     * Gets action
     *
     * @return \SLIS\Adapter\Tanss\Model\InlineResponse20065ContentAllOfItemsItemsAction|null
     */
    public function getAction()
    {
        return $this->container['action'];
    }

    /**
     * Sets action
     *
     * @param \SLIS\Adapter\Tanss\Model\InlineResponse20065ContentAllOfItemsItemsAction|null $action action
     *
     * @return self
     */
    public function setAction($action)
    {
        $this->container['action'] = $action;

        return $this;
    }

    /**
     * Gets vars
     *
     * @return \SLIS\Adapter\Tanss\Model\InlineResponse20048ContentItemsAllOfVarsInner[]|null
     */
    public function getVars()
    {
        return $this->container['vars'];
    }

    /**
     * Sets vars
     *
     * @param \SLIS\Adapter\Tanss\Model\InlineResponse20048ContentItemsAllOfVarsInner[]|null $vars if vars were used in teh text, these must be given in the \"check\" body to fill in the correct values / infos for checking the item
     *
     * @return self
     */
    public function setVars($vars)
    {
        $this->container['vars'] = $vars;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    #[\ReturnTypeWillChange]
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


